﻿using Kivii.Linq;
using Kivii.Third.Scjgj.Entities;
using Kivii.Web;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Third.Scjgj
{
    [RequiresAnyRole(MemberRoles.Everyone)]
    public class PlanQuery : RestfulExecution<Plan>
    {
        //public int? Skip { get; set; } = 0;

        //public int? Take { get; set; } = 50;

        //public string OrderBy { get; set; }
        //public string QueryKeys { get; set; }

        //public string QueryValues { get; set; }
        #region QueryArgs
        public virtual int? Skip { get; set; }

        public virtual int? Take { get; set; }

        public virtual string OrderBy { get; set; }

        public string OrderByDesc { get; set; }

        public virtual string Include { get; set; }

        public virtual string Fields { get; set; }

        public string QueryKeys { get; set; }

        public string QueryValues { get; set; }

        #endregion
        public override object OnExecution(IRequest req, IResponse res)
        {

            //var rtns = new RestfulQueryResponse<Plan>();
            //rtns.Results = new List<Plan>();
            //var conn = KiviiContext.GetOpenedDbConnection<Plan>();
            //var query = conn.From<Plan>();
            //if (!QueryValues.IsNullOrEmpty()) query.Where(o => o.PLAN_CODE.Contains(QueryValues));
            //if (Skip.HasValue && Skip.Value >= 0) query.Skip(Skip.Value);
            //if (Take.HasValue && Take.Value > 0) query.Take(Take.Value);
            //if (!OrderBy.IsNullOrEmpty()) query.OrderBy(OrderBy);
            //rtns.Results = conn.Select(query);

            //rtns.Total = rtns.Results.Count;
            //return rtns;
            var conn = KiviiContext.GetOpenedDbConnection<Plan>();
            var dynamicParams = Request.GetRequestParams();
            var autoQuery = Request.TryResolve<IAutoQueryDb>();
            autoQuery.IncludeTotal = true;
            var request = new RestfulQuery<Plan>();
            request = request.PopulateWith(this);
            var sqlExpress = autoQuery.CreateQuery(Request, conn, request, dynamicParams);
            var rtns = autoQuery.Execute(Request, conn, request, sqlExpress);
            return rtns;
        }
    }

    [RequiresAnyRole(MemberRoles.Everyone)]
    public class PlanDetailQuery : RestfulExecution<PlanDetail>
    {
        //public int? Skip { get; set; } = 0;

        //public int? Take { get; set; } = 50;

        //public string OrderBy { get; set; }
        //public string QueryKeys { get; set; }

        //public string QueryValues { get; set; }
        #region QueryArgs
        public virtual int? Skip { get; set; }

        public virtual int? Take { get; set; }

        public virtual string OrderBy { get; set; }

        public string OrderByDesc { get; set; }

        public virtual string Include { get; set; }

        public virtual string Fields { get; set; }

        public string QueryKeys { get; set; }

        public string QueryValues { get; set; }

        #endregion
        public override object OnExecution(IRequest req, IResponse res)
        {

            //var rtns = new RestfulQueryResponse<Plan>();
            //rtns.Results = new List<Plan>();
            //var conn = KiviiContext.GetOpenedDbConnection<Plan>();
            //var query = conn.From<Plan>();
            //if (!QueryValues.IsNullOrEmpty()) query.Where(o => o.PLAN_CODE.Contains(QueryValues));
            //if (Skip.HasValue && Skip.Value >= 0) query.Skip(Skip.Value);
            //if (Take.HasValue && Take.Value > 0) query.Take(Take.Value);
            //if (!OrderBy.IsNullOrEmpty()) query.OrderBy(OrderBy);
            //rtns.Results = conn.Select(query);

            //rtns.Total = rtns.Results.Count;
            //return rtns;
            var conn = KiviiContext.GetOpenedDbConnection<PlanDetail>();
            var dynamicParams = Request.GetRequestParams();
            var autoQuery = Request.TryResolve<IAutoQueryDb>();
            autoQuery.IncludeTotal = true;
            var request = new RestfulQuery<PlanDetail>();
            request = request.PopulateWith(this);
            var sqlExpress = autoQuery.CreateQuery(Request, conn, request, dynamicParams);
            var rtns = autoQuery.Execute(Request, conn, request, sqlExpress);
            return rtns;
        }
    }

    //[RequiresAnyRole(MemberRoles.Everyone)]
    //public class PlanDetailQuery : RestfulExecution<PlanDetail>
    //{
    //    public int? Skip { get; set; } = 0;

    //    public int? Take { get; set; } = 50;

    //    public string OrderBy { get; set; }
    //    public string QueryKeys { get; set; }

    //    public string QueryValues { get; set; }
    //    public override object OnExecution(IRequest req, IResponse res)
    //    {
    //        var rtns = new RestfulQueryResponse<PlanDetail>();
    //        rtns.Results = new List<PlanDetail>();
    //        var conn = KiviiContext.GetOpenedDbConnection<Plan>();
    //        var query = conn.From<PlanDetail>();
    //        if (!QueryValues.IsNullOrEmpty()) query.Where(o => o.PLAN_CODE.Contains(QueryValues));
    //        if (Skip.HasValue&&Skip.Value>=0) query.Skip(Skip.Value);
    //        if (Take.HasValue&&Take.Value>0) query.Take(Take.Value);
    //        if (!OrderBy.IsNullOrEmpty()) query.OrderBy(OrderBy);
    //        rtns.Results = conn.Select(query);

    //        rtns.Total = rtns.Results.Count;
    //        return rtns;
    //    }
    //}
}
